#include <stdio.h>
#include <string.h>
#define MAXSTR 512

#include "sptree.h"

static int comp(a, b)
#ifdef INTKEY
	int a, b;
{
	return a - b;
}
#else
	char *a, *b;
{
	return strcmp(a, b);
}
#endif

#define prompt() if(prompt_p) printf(":"); else ;
main()
{
	char buf[MAXSTR];
 	char cmd[8], datum[MAXSTR];
	char *cp;
#ifndef INTKEY
	char key[MAXSTR];
#	define KEYSTR "string1"
#else
	int key;
#	define KEYSTR "int"
#endif
	SPBLK *result;
	int prompt_p;
	SPTREE *sp;
	int prnode();

	sp = spinit(comp);
	prompt_p = isatty(fileno(stdin));
	prompt();
	while(fgets(buf, sizeof(buf), stdin) != NULL) {
#ifndef INTKEY
		sscanf(buf, " %s %s", cmd, key);
#else
		sscanf(buf, " %s %d", cmd, &key);
#endif
		switch (*cmd) {
		case 'a':
			sscanf(buf, " %*s %*s %[^\n]s", datum);
#ifndef INTKEY
			cp = strdup(key);
#else
			cp = (char *) key;
#endif
			spinstall(cp, sp);
			break;
		case 's':
			if ((result = splookup(key, sp)) != NULL)
#ifndef INTKEY
				printf("found %s\n", result->key);
#else
				printf("found %d\n", result->key);
#endif
			else
				printf("no match\n");
			break;
		case 'd':
			if ((result = splookup(key, sp)) != NULL)
				spdelete(result, sp);
			else
				printf("no match\n");
			break;
		case 'p':
			spscan(prnode, NULL, sp);
			printf("Stats = %s\n", spstats(sp));
			fflush(stdout);
			break;
		default:
			printf("'a %s string2' inserts datum (string2) keyed by %s\n",
			 KEYSTR, KEYSTR);
			printf("'s %s' prints the datum associated with %s if any\n",
			 KEYSTR, KEYSTR);
			printf("'d %s' deletes the datum associated with %s if any\n",
			 KEYSTR, KEYSTR);
			printf("'p' prints all the items so far\n");
			break;
		}
		prompt();
	}
	printf("\n");
}

int
prnode(spblk, arg)
SPBLK *spblk;
{
#ifndef INTKEY
	printf("%s", spblk->key);
#else
	printf("%d", spblk->key);
#endif
	printf(" %.8x [u=%.8x, l=%.8x, r=%.8x]\n",
	       spblk, spblk->uplink, spblk->leftlink, spblk->rightlink);
}
